<?php
/*
 * Provider: A class that generate the GUI for the voip provider wizard.
 *
 * Copyright (C) 2017 beroNet GmbH
 *
 * Author: Miguel Palmer <mp@beronet.com>
 */

require_once '/usr/local/www/berogui/includes/Helper/HelperSip.php';
require_once '/usr/local/www/berogui/includes/Helper/Helper.php';
require_once '/usr/local/www/berogui/modules/ProfileManagement/ProfileManagement.php';
require_once '/usr/local/php/include/sipProfileDownloader.Class.php';

class Provider {

	function tones($group, $tones = "") {
		exec('/bin/cat /usr/conf/isgw.tones | /bin/grep "^\[.*\]$" ', $ausgabe);

		$select = "<select class=\"form-control input-sm\" name=\"tones-$group\" id=\"tones-$group\">";
		foreach ($ausgabe as $value) {

			if ($tones == "") {
				if ($value == "[de]") {
					$select .= "<option value=\"" . $value . "\" selected>" . $value . "</option>";
				} elseif ($value != "[general]") {
					$select .= "<option value=\"" . $value . "\">" . $value . "</option>";
				}
			} else {
				if ($value == $tones) {
					$select .= "<option value=\"" . $value . "\" selected>" . $value . "</option>";
				} elseif ($value != "[general]") {
					$select .= "<option value=\"" . $value . "\">" . $value . "</option>";
				}
			}
		}
		$select .= "</select>";
		return $select;
	}

	/**
	 * 
	 * @return typeGeneriert die HTML Seite
	 */
	function display() {

		require_once "./misc/config_parameter.php";

		$name = "VoIP Provider Wizard";
		define("VOIP_PROVIDER_WIZARD", $name);
		$name = "VOIP_PROVIDER_WIZARD";
		include "./includes/header.php";
		require_once "./includes/lang.php";

		//Save
		$ret .= "<br/>";
		$sent = $_POST["submit"];
		if ($sent == "Save") {
			$ret .= $this->createconfigfiles();
		}
		if (isset($_POST['download'])) {
			$profDown = new sipProfileDownloader();
			ob_start();
			if ($profDown->downloadProfile($_POST['url']) == false) {
				?>
				<div class="text-center" style="color: red;">
					<img src="/app/berogui/includes/images/punkt_rot.gif" />
					Error downloading <strong><? echo basename($_POST['url']) ?></strong>!
				</div>
			<? } else { ?>
				<div class="text-center">
					<img src="/app/berogui/includes/images/punkt_gruen.gif" />
					<strong><? echo basename($_POST['url']) ?></strong> has been downloaded and installed!
				</div>
				<?php
			}
			$ret .= ob_get_clean();
		}

		if (isset($_POST['upload'])) {
			$profile = new ProfileManagement();
			$profile->_upload();
		}

		$ba = new beroAri();

		$lif = Helper::getLif();



		//HEADER
		for ($i = 0; $i < Helper::getLifCount(); $i++) {
			switch ($lif[$i]) {
				case "bf4S0":
					$types[$i] = "BRI";
					$ports[$i] = "4";
					$start[$i] = "isdn";
					break;
				case "bf2S0":
					$types[$i] = "BRI";
					$ports[$i] = "2";
					$start[$i] = "isdn";
					break;
				case "bf1S0":
					$types[$i] = "BRI";
					$ports[$i] = "1";
					$start[$i] = "isdn";
					break;
				case "bf1E1":
					$types[$i] = "PRI";
					$ports[$i] = "1";
					$start[$i] = "isdn";
					break;
				case "bf2E1":
					$types[$i] = "PRI";
					$ports[$i] = "2";
					$start[$i] = "isdn";
					break;
				case "bf2S02FXS":
					$types[$i] = "BRI";
					$ports[$i] = "2";
					$start[$i] = "isdn";
					break;
				default:
					$types[$i] = "none";
					$ports[$i] = "0";
					break;
			}
		}

		//Support just for BRI and PRI modules
		if (!in_array('PRI', $types) && !in_array('BRI', $types)) {
			ob_start();
			?>
			<br>
			<br>
			<div class="text-center">
				<p class='bg-danger lead'><? echo PROVIDER_CONFIG_SUPPORT_DIS ?></p>
			</div>
			<?php
			$ret .= ob_get_clean();
			return $ret;
		}
		$ProfDown = new sipProfileDownloader();
		$sipProfiles = $ProfDown->readProfileList();
		ob_start();
		?>		
		<br/>
		<script type="text/javascript">
		    $("#sip_registrar").keyup(function () {
		        required();
		    });
		    $("#sip_proxy").keyup(function () {
		        required();
		    });
		    function confirmSubmit() {
		        if ($('providerForm').valid()) {
		            var agree = confirm('Note !!! If you continue all previous configurations\non the beroNet Gateway will be deleted. '
		                    + 'Press ok if want to proceed!\nNew Config has to be activated and the gateway has to be rebooted.');
		            if (agree) {
		                return true;
		            } else {
		                return false;
		            }
		        }
		    }
		    $(document).ready(function () {
		        validation();
		    });
		    function portType() {
		        if ($("input[value='PRI']").prop('checked')) {
		            $('.pri-table').removeClass('hidden');
		            $('.sip-table').removeClass('hidden');
		            $('.bri-table').addClass('hidden');
		            $('.bri-table').find('input,button,textarea,select').prop('disabled', 'disabled');
		            $('.pri-table').find('input,button,textarea,select').removeProp('disabled');
		        } else if ($("input[value='BRI']").prop('checked')) {
		            $('.pri-table').addClass('hidden');
		            $('.pri-table').find('input,button,textarea,select').prop('disabled', 'disabled');
		            $('.bri-table').find('input,button,textarea,select').removeProp('disabled');
		            $('.bri-table').removeClass('hidden');
		            $('.sip-table').removeClass('hidden');
		        }
		    }
		    $('#profile-tab a').click(function (e) {
		        e.preventDefault();
		        $(this).tab('show');
		    });
		</script>
		<div class='text-center'>
			<p class='lead'><? echo PROVIDER_PROFILE_MANAGEMENT_DIS; ?></p>
		</div>
		<div class="col-lg-2"></div>
		<div class="col-lg-8">
			<ul class='nav nav-tabs' role='tablist' id='profile-tab'>
				<li role='presentation' class='active'>
					<a href='#install' aria-controls='Install profile' role='tab' data-toggle='tab'>
						<? echo PROVIDER_INSTALL_PROFILE_DIS ?>
					</a>
				</li>
				<li role='presentation'>
					<a href='#search' aria-controls='Search for profiles' role='tab' data-toggle='tab'>
						<? echo PROVIDER_SEARCH_PROFILE_DIS ?>
					</a>
				</li>
			</ul>

			<div class='tab-content' data-toggle='tooltip' title='<? echo PROVIDER_PROFILE ?>'>
				<div role='tabpanel' class='tab-pane active' id='install' style='padding-top:15px;'>
					<form class="form-horizontal" action='' method='POST' ENCTYPE='multipart/form-data'>
						<div class='form-group'>
							<label for='uploadfile' class='col-sm-3 control-label'><? echo PROFILE_MANAGEMENT_UPLOAD_PROFILE ?></label>
							<div class='col-sm-6'>
								<input type='file' size='28' name='uploadfile'>
							</div>
						</div>
						<br>
						<div class="text-center">
							<input name='upload' class='btn btn-default' type='submit' value='<? echo BUTTON_UPLOAD ?>'>
						</div>
					</form>
				</div>
				<div role='tabpanel' class='tab-pane' id='search' style='padding-top:15px;'>
					<div class="row">
						<div class="col-sm-4"><p class="lead"><? echo SIP_PROFILE_NAME ?></p></div>
						<div class="col-sm-2"><p class="lead"><? echo SIP_PROFILE_VERS ?></p></div>
						<div class="col-sm-4"><p class="lead"><? echo SIP_PROFILE_DESC ?></p></div>
						<div class="col-sm-2"><p class="lead"><? echo SIP_PROFILE_ACTN ?></p></div>
					</div>
					<? foreach ($sipProfiles as $s) { ?>
						<div class="row">
							<div class="col-sm-4"> <? echo $s['name'] ?></div>
							<div class="col-sm-2"> <? echo $s['version'] ?></div>
							<div class="col-sm-4"> <? echo $s['meta-text'] ?></div>
							<div class="col-sm-2">
								<form name="sip_download" id="sip_general" method="POST">
									<input type="hidden" name="url" value="<? echo $s['url'] ?>">
									<input type="submit" class="btn btn-default" name="download" value="<? echo BUTTON_DOWNLOAD ?>">
								</form>
							</div>
						</div>
					<? } ?>
				</div>
			</div>
		</div>
		<div class="clearfix"></div>
		<br>
		<hr>
		<br>
		<form action='' id='providerForm' method='POST' class='form-horizontal'>
			<input type='password' name='dummy' style='display:none'>
			<input type='hidden' value='nt' name='ntte'>
			<div class='text-center'>
				<p class='lead'>ISDN</p>
			</div>
			<div class='form-group'>
				<label for='port_type' class='col-sm-5 control-label'><? echo PROVIDER_PORTTYPE_DIS ?></label>
				<div class='col-sm-6'>
					<?php
					$ret .= ob_get_clean();
					if (in_array('PRI', $types)) {
						ob_start();
						?>
						<div class='radio'>
							<label><input type='radio' name='port_type' value='PRI' onchange='portType();'>PRI</label>
						</div>
						<?php
						$ret .= ob_get_clean();
					}
					if (in_array('BRI', $types)) {
						ob_start();
						?>
						<div class='radio'>
							<label><input type='radio' name='port_type' value='BRI' onchange='portType();'>BRI</label>
						</div>
						<?php
						$ret .= ob_get_clean();
					}
					ob_start();
					?>
				</div>
			</div>
			<?php
			$ret .= ob_get_clean();
			// ISDN PRI
			if (in_array('PRI', $types)) {
				ob_start();
				?>
				<br/>
				<div class='hidden pri-table'>
					<div class='text-center'>
						<p class='lead'>ISDN PRI</p>
					</div>
					<div class='form-group'>
						<label for='port[]' class='col-sm-5 control-label'><? echo PROVIDER_PRI_PORT_DIS; ?></label>
						<div class='col-sm-6'>
							<?php
							$ret .= ob_get_clean();
							$startPort = 1;
							foreach ($types as $li => $type) {
								if ($type == "PRI") {
									if ($checkPri != "") {
										ob_start();
										?>
										<br/>
										<?php
										$checkPri .= ob_get_clean();
									}
									ob_start();
									?>
									Available Ports Lif<? echo $li ?> (PRI):
									<?php
									$checkPri .= ob_get_clean();
									$control = $startPort + $ports[$li];
									for ($j = $startPort; $j < $control; $j++) {
										ob_start();
										?>
										<input type='checkbox' value='PRI-<? echo $j ?>' id='PRI-<? echo $j ?>' name='port[]' checked><? echo $j ?>
										<?php
										$checkPri .= ob_get_clean();
									}
									$startPort = $startPort + $ports[$li];
								} elseif ($start[$li] == "isdn") {
									$startPort = $startPort + $ports[$li];
								}
							}

							$ret .= $checkPri;
							ob_start();
							?>
							<input type='hidden' value='ISDN-PRI' name='group-ISDN-PRI'>
						</div>
					</div>
					<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_TONES ?>'>
						<label for='tones-ISDN-PRI' class='col-sm-5 control-label'><? echo PROVIDER_TONES_DIS ?></label>
						<div class='col-sm-6'>
							<? echo $this->tones("ISDN-PRI", "") ?>
						</div>
					</div>
					<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_COUNTRY_CODE ?>'>
						<label for='ISDN-country_code-PRI' class='col-sm-5 control-label'><? echo PSTN_COUNTRY_CODE_DIS ?></label>
						<div class='col-sm-6'>
							<input name='ISDN-country_code-PRI' class='form-control input-sm' value="<? echo $ba->get('international_code') ?>">
						</div>
					</div>
					<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_CITY_CODE ?>'>
						<label for='ISDN-city_code-PRI' class='col-sm-5 control-label'><? echo PSTN_CITY_CODE_DIS ?></label>
						<div class='col-sm-6'>
							<input name='ISDN-city_code-PRI' class='form-control input-sm' value="<? echo $ba->get('national_code') ?>">
						</div>
					</div>
				</div>
				<?php
				$ret .= ob_get_clean();
			}
			// ISDN BRI
			if (in_array('BRI', $types)) {
				ob_start();
				?>
				<br/>
				<div class='hidden bri-table'>
					<div class='text-center'>
						<p class='lead'>ISDN BRI</p>
					</div>
					<div class='form-group'>
						<label for='port[]' class='col-sm-5 control-label'><? echo PROVIDER_BRI_PORT_DIS ?></label>
						<div class='col-sm-6'>
							<?php
							$ret .= ob_get_clean();
							$startPort = 1;
							foreach ($types as $li => $type) {
								if ($type == "BRI") {
									if ($checkBri != "") {
										ob_start();
										?>
										<br/>
										<?php
										$checkBri .= ob_get_clean();
									}
									ob_start();
									?>
									<input type='hidden' name='briLi[]' value='<? echo $li ?>'>
									Available Ports Lif<? echo $li ?> (BRI):
									<?php
									$checkBri .= ob_get_clean();
									$control = $startPort + $ports[$li];
									for ($j = $startPort; $j < $control; $j++) {
										ob_start();
										?>
										<input type='checkbox' value='BRI-<? echo $j ?>' id='BRI-<? echo $j ?>' name='port[]' checked><? echo $j ?>
										<?php
										$checkBri .= ob_get_clean();
									}
									$startPort = $startPort + $ports[$li];
								} elseif ($start[$li] == "isdn") {
									$startPort = $startPort + $ports[$li];
								}
							}

							$ret .= $checkBri;
							ob_start();
							?>
						</div>
					</div>
					<div class='form-group' data-toggle='tooltip' title='<? echo ISDNHW_PTP ?>'>
						<label for='ptp' class='col-sm-5 control-label'><? echo PROVIDER_PTP_DIS ?></label>
						<div class='col-sm-6'>
							<select name='ptp' class='form-control input-sm' id='ptp'>
								<option value='1' selected>PTP</option>
								<option value='0'>PMP</option>
							</select>
							<input type='hidden' value='ISDN-BRI' name='group-ISDN-BRI'>
						</div>
					</div>
					<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_TONES ?>'>
						<label for='tones-ISDN-BRI' class='col-sm-5 control-label'><? echo PROVIDER_TONES_DIS ?></label>
						<div class='col-sm-6'>
							<? echo $this->tones("ISDN-BRI", "") ?>
						</div>
					</div>
					<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_COUNTRY_CODE ?>'>
						<label for='ISDN-country_code-BRI' class='col-sm-5 control-label'><? echo PSTN_COUNTRY_CODE_DIS ?></label>
						<div class='col-sm-6'>
							<input name='ISDN-country_code-BRI' class='form-control input-sm' value="<? echo $ba->get('international_code') ?>">
						</div>
					</div>
					<div class='form-group' data-toggle='tooltip' title='<? echo ISDN_CITY_CODE ?>'>
						<label for='ISDN-city_code-BRI' class='col-sm-5 control-label'><? echo PSTN_CITY_CODE_DIS ?></label>
						<div class='col-sm-6'>
							<input name='ISDN-city_code-BRI' class='form-control input-sm' value="<? echo $ba->get('national_code') ?>">
						</div>
					</div>
				</div>
				<?php
				$ret .= ob_get_clean();
			}
			//SIP
			ob_start();
			?>

			<br/>
			<div class='hidden sip-table'>
				<div class='text-center'>
					<p class='lead'>SIP</p>
				</div>
				<div class='form-group'>
					<label for='profile' class='col-sm-5 control-label'><? echo PROVIDER_PROFILE_DIS ?></label>
					<div class='col-sm-6'>
						<? echo HelperSip::profiles(FALSE) ?>
					</div>
				</div>
				<div class='sip-content hidden'></div>
			</div>
			<br/>
			<br/>
			<div class='text-center'>
				<input type='submit' class='btn btn-default' name='submit' value='Save' onClick='return confirmSubmit()'>
			</div>
		</form>
		<script type='text/javascript'>
		    function validation() {
		        $("#providerForm").validate({
		            rules: {
		                port_type: {
		                    required: true,
		                },
		                name: {
		                    required: true,
		                    specChar: true,
		                    checkBlank: true,
		                },
		                user: "specChar",
		                displayname: "specChar",
		                auth_user: "specChar",
		                secret: "specChar",
		                'srtp_crypto_suites[]': {
		                    required: {
		                        depends: function () {
		                            return ($("#srtp_mode").val() === "mandatory" || $("#srtp_mode").val() === "optional");
		                        }
		                    }
		                },
		                sip_from_user_setting_manual: {
		                    specChar: "#sip_from_user_setting_manual:visible",
		                },
		                sip_from_display_setting_manual: {
		                    specChar: "#sip_from_display_setting_manual:visible",
		                },
		                sip_proxy: {
		                    checkHostname: true,
		                    required: {
		                        depends: function () {
		                            return ($("#sip_registrar").is(":blank") && !$("#enum_search_domains").is(":visible"));
		                        }
		                    },
		                    sipPortCheck: "<?php echo HelperSip::udpports($ba); ?>"
		                },
		                sip_registrar: {
		                    checkHostname: true,
		                    required: {
		                        depends: function () {
		                            return ($("#sip_proxy").is(":blank") && !$("#enum_search_domains").is(":visible"));
		                        }
		                    },
		                    sipPortCheck: "<?php echo HelperSip::udpports($ba); ?>"
		                },
		                enum_search_domains: {
		                    required: true,
		                },
		                regrefresh: {
		                    required: true,
		                    range: [30, 86400]
		                },
		                sip_custom_port: {
		                    range: [1025, 65535]
		                },
		                keepalive_interval: {
		                    required: true,
		                    range: [0, 86400]
		                },
		                'ISDN-country_code-BRI': {
		                    required: true,
		                    checkPhoneNumber: true
		                },
		                'ISDN-city_code-BRI': {
		                    required: true,
		                    digits: true
		                },
		                'ISDN-country_code-PRI': {
		                    required: true,
		                    checkPhoneNumber: true
		                },
		                'ISDN-city_code-PRI': {
		                    required: true,
		                    digits: true
		                },
		                'port[]': {
		                    atLeastOnePort: true,
		                }
		            },
		            highlight: function (element) {
		                $(element).closest('.form-group').addClass('has-error');
		            },
		            unhighlight: function (element) {
		                $(element).closest('.form-group').removeClass('has-error');
		            },
		            errorPlacement: function (error, element) {
		                error.appendTo(element.closest('.col-sm-6'));
		            }
		        });
		    }
		    function showSettings(thisObj) {
		        type = $('#type').val();
		        if (thisObj.val() == 'manual') {
		            $('.sip-content').addClass('hidden');
		        } else {
		            $('.sip-content').removeClass('hidden');
		            $('.sip-content').load('modules/Provider/ajax-provider.php?category=' + encodeURI(type) + '&profile=' + encodeURI(thisObj.val()), function (res) {
		            });
		        }
		    }
		    $('.profile').change(function () {
		        showSettings($(this));
		    });
		</script>
		<br/>
		<?php
		$ret .= ob_get_clean();

		return $ret;
	}

	/**
	 * Generiert den Config String
	 * @param boolean $bri
	 * @param string $config
	 * @return string Config String
	 */
	function parameters($bri = FALSE, $config = "") {
		$default = Helper::getDefaultConfig();

		foreach ($_POST as $key => $value) {
			$_POST[$key] = str_replace("'", "\"", $_POST[$key]);
		}

		$configParam = array_diff(HelperSip::$configSave, array('sip_national_code', 'sip_international_code'));
		foreach (HelperSip::$configSave as $option) {
			if (isset($_POST[$option]) && $_POST[$option] != $default[$option])
				$config .= ',' . $option . '=' . $_POST[$option];
		}

		//SRTP_CRYPTO_SUITES
		$c = "";
		for ($i = 0; $i < count($_POST['srtp_crypto_suites']); $i++) {
			if ($c != "")
				$c .= ":";
			$c .= $_POST['srtp_crypto_suites'][$i];
		}
		if ($c != "")
			$config .= ",srtp_crypto_suites=" . $c;

		//SIP_TO_USER_SETTING
		if (isset($_POST['sip_to_user_setting']) && $_POST['sip_to_user_setting'] != 'manual' && $_POST['sip_to_user_setting'] != $default['sip_to_user_setting']){
			$config .= ",sip_to_user_setting=" . $_POST['sip_to_user_setting'];
		}else if (isset($_POST['sip_to_user_setting']) && $_POST['sip_to_user_setting'] == 'manual'){
			$config .= ",sip_to_user_setting=" . $_POST['sip_to_user_setting_manual'];
		}

		//SIP_FROM_USER_SETTING
		if (isset($_POST['sip_from_user_setting']) && $_POST['sip_from_user_setting'] != 'manual' && $_POST['sip_from_user_setting'] != $default['sip_from_user_setting']){
			$config .= ",sip_from_user_setting=" . $_POST['sip_from_user_setting'];
		}else if (isset($_POST['sip_from_user_setting']) && $_POST['sip_from_user_setting'] == 'manual'){
			$config .= ",sip_from_user_setting=" . $_POST['sip_from_user_setting_manual'];
		}

		//SIP_FROM_DISPLAY_SETTING
		if (isset($_POST['sip_from_display_setting']) && $_POST['sip_from_display_setting'] != 'manual' && $_POST['sip_from_display_setting'] != $default['sip_from_display_setting']){
			$config .= ",sip_from_display_setting=" . $_POST['sip_from_display_setting'];
		}else if (isset($_POST['sip_from_display_setting']) && $_POST['sip_from_display_setting'] == 'manual'){
			$config .= ",sip_from_display_setting=" . $_POST['sip_from_display_setting_manual'];
		}

		//CODECS
		$c = "";
		for ($i = 0; $i < count($_POST['codecs']); $i++) {
			if ($c != ""){
				$c .= ":";
			}
			$c .= $_POST['codecs'][$i];
		}
		if ($c != "" && $c != $default['codecs']){
			$config .= ",codecs=" . $c;
		}

		$config .= ($bri === TRUE) ? ",sip_national_code=" . $_POST["ISDN-city_code-BRI"] . ",sip_international_code=" . $_POST["ISDN-country_code-BRI"] 
			: ",sip_national_code=" . $_POST["ISDN-city_code-PRI"] . ",sip_international_code=" . $_POST["ISDN-country_code-PRI"];

		$config = trim($config, ",");

		return $config;
	}

	/**
	 * Speichert die Daten in der Datenbank
	 * @return string HTML code
	 */
	function createconfigfiles() {

		$strpath = "/usr/conf/";
		@unlink($strpath . "ari.db");
		$ba = new beroAri();

		//PSTN Config
		foreach ($_POST["port"] as $value) {
			$bri = $pri = false;
			$port = explode("-", $value);
			switch ($port[0]) {
				case "BRI":
					$bri = true;
					$tones = $_POST["tones-ISDN-BRI"];
					$country_code = $_POST['ISDN-country_code-BRI'];
					$city_code = $_POST['ISDN-city_code-BRI'];
					$group = $_POST["group-ISDN-BRI"];
					$ptp = $_POST["ptp"];
					$ntte = $_POST["ntte"];
					$config = "isdn_oad_setting = \${new_source_auto}, isdn_dad_setting = \${new_destination_auto}";
					foreach ($_POST['briLi'] as $lif) {
						$ba->set("sync_port_li" . $lif, '1');
					}
					$ba->update("UPDATE isdn SET clock='0';");
					$ba->update("UPDATE isdn SET gr='" . sqlite_escape_string($group) . "',"
						. " ptp='" . sqlite_escape_string($ptp) . "',"
						. " ntteSW='" . sqlite_escape_string($ntte) . "',"
						. " ntteHW='" . sqlite_escape_string($ntte) . "',"
						. " tones='" . sqlite_escape_string($tones) . "',"
						. " country_code='" . sqlite_escape_string($country_code) . "',"
						. " city_code='" . sqlite_escape_string($city_code) . "',"
						. " config='" . sqlite_escape_string($config) . "'"
						. " WHERE port='" . sqlite_escape_string($port[1]) . "'");
					break;
				case "PRI":
					$pri = true;
					$tones = $_POST["tones-ISDN-PRI"];
					$group = $_POST["group-ISDN-PRI"];
					$ntte = $_POST["ntte"];
					$country_code = $_POST['ISDN-country_code-PRI'];
					$city_code = $_POST['ISDN-city_code-PRI'];
					$config = "isdn_oad_setting = \${new_source_auto}, isdn_dad_setting = \${new_destination_auto}";

					$config = $ba->update("UPDATE isdn SET gr='" . sqlite_escape_string($group) . "',"
						. " ntteSW='" . sqlite_escape_string($ntte) . "', "
						. "ntteHW='" . sqlite_escape_string($ntte) . "', "
						. "tones='" . sqlite_escape_string($tones) . "', "
						. "country_code='" . sqlite_escape_string($country_code) . "', "
						. "city_code='" . sqlite_escape_string($city_code) . "', "
						. "crystal_clock='1', "
						. "config='" . sqlite_escape_string($config) . "' "
						. "WHERE port='" . sqlite_escape_string($port[1]) . "'");
					break;
				default:
					break;
			}
		}
		$ba->set('master', 'all');


		//SIP entry
		$name = $_POST['name'];
		$sip_proxy = $_POST['sip_proxy'];
		$sip_registrar = $_POST['sip_registrar'];
		$sip_domain = $_POST['sip_domain'];
		$user = sqlite_escape_string($_POST['user']);
		$auth_user = sqlite_escape_string($_POST['auth_user']);
		$displayname = sqlite_escape_string($_POST['displayname']);
		if (is_array($_POST['matchtype'])) {
			foreach ($_POST['matchtype'] as $type) {
				$matchtype .= ($matchtype == "") ? "" : "|";
				$matchtype .= $type;
			}
			if (in_array('manual', $_POST['matchtype']))
				$matchtype_manual = $_POST['matchtype_manual'];
		}
		$profile = sqlite_escape_string($_POST['profile']);
		$secret = sqlite_escape_string($_POST['secret']);
		$sip_transport = $_POST['sip_transport'];
		$sip_custom_port = $_POST['sip_custom_port'];
		$register = $_POST['register'];
		$enum_support = $_POST['enum_support'];
		$enum_search_domains = $_POST['enum_search_domains'];
		$call_transfer_method = $_POST['call_transfer_method'];
		if ($_POST['option'] == "stun")
			$stunserver = $_POST['stunserver'];
		if ($register == 1) {
			$regrefresh = $_POST['regrefresh'];
			$register_option = $_POST['register_option'];
			$keepalive_interval = $_POST['keepalive_interval'];
		} else {
			$regrefresh = "";
			$register_option = "no-validate no-options-keepalive";
			$keepalive_interval = "30";
		}
		if ($_POST['option'] == "externip")
			$externip = $_POST['externip'];
		if ($_POST['option'] == "nonat") {
			$externip = "";
			$stunserver = "";
		}
		$config = $this->parameters($bri);


		$query_new = $ba->insert_('INSERT INTO sip (name, sip_transport, sip_proxy, sip_registrar, sip_domain, '
			. 'user, auth_user, displayname, secret, register,  config, externip, stunserver, regrefresh, '
			. 'register_option, profile, matchtype, matchtype_manual, enum_support, enum_search_domain,'
			. ' keepalive_interval, call_transfer_method, sip_custom_port) '
			. 'VALUES (\'' . sqlite_escape_string($name) . '\', \'' . sqlite_escape_string($sip_transport) . '\', \'' . sqlite_escape_string($sip_proxy) . '\', '
			. '\'' . sqlite_escape_string($sip_registrar) . '\', \'' . sqlite_escape_string($sip_domain) . '\', \'' . sqlite_escape_string($user) . '\', '
			. '\'' . sqlite_escape_string($auth_user) . '\', \'' . sqlite_escape_string($displayname) . '\', \'' . sqlite_escape_string($secret) . '\', \'' . sqlite_escape_string($register) . '\','
			. '\'' . sqlite_escape_string($config) . '\',\'' . sqlite_escape_string($externip) . '\',\'' . sqlite_escape_string($stunserver) . '\',\'' . sqlite_escape_string($regrefresh) . '\','
			. '\'' . sqlite_escape_string($register_option) . '\',\'' . sqlite_escape_string($profile) . '\',\'' . sqlite_escape_string($matchtype) . '\',\'' . sqlite_escape_string($matchtype_manual) . '\','
			. '\'' . sqlite_escape_string($enum_support) . '\',\'' . sqlite_escape_string($enum_search_domains) . '\', \'' . sqlite_escape_string($keepalive_interval) . '\','
			. '\'' . sqlite_escape_string($call_transfer_method) . '\', \'' . sqlite_escape_string($sip_custom_port) . '\')');

		//Dialplan entries
		$dest = "(.*)";
		$newdest = "\\\\1";
		$src = "(.*)";
		$newsrc = "\\\\1";
		$activ = 1;
		$posId = 0;
		$config = "";


		//Dialplan Rule ISDN=>SIP
		$toid = "p:" . $name;
		$group = ($bri === true) ? $_POST["group-ISDN-BRI"] : $_POST["group-ISDN-PRI"];
		$fromid = "g:" . $group;
		$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, activ, config) VALUES ('isdn','sip','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId++) . "', '" . sqlite_escape_string($activ) . "', '" . sqlite_escape_string($config) . "')");
		//Dialplan Rule SIP=>ISDN
		$fromid = "a:" . $name;
		$toid = "g:" . $group;
		$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, activ) VALUES ('sip','isdn','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId++) . "', '" . sqlite_escape_string($activ) . "')");



		$ret = Helper::activate(3, true, 'Provider');
		return $ret;
	}

}
